#ifndef __PlatformIntegrationData__
#define __PlatformIntegrationData__

namespace LWE {
// This table has same chars with
// ASCII printable char(32-126)
enum KeyValue {
    UnidentifiedKey,
    AltLeftKey,
    AltRightKey,
    ControlLeftKey,
    ControlRightKey,
    CapsLockKey,
    FnKey,
    FnLockKey,
    HyperKey,
    MetaKey,
    NumLockKey,
    ScrollLockKey,
    ShiftLeftKey,
    ShiftRightKey,
    SuperKey,
    SymbolKey,
    SymbolLockKey,
    EnterKey,
    TabKey,
    ArrowDownKey,
    ArrowUpKey,
    ArrowLeftKey,
    ArrowRightKey,
    EndKey,
    HomeKey,
    PageDownKey,
    PageUpKey,
    BackspaceKey,
    DeleteKey,
    InsertKey,
    ContextMenuKey,
    EscapeKey,
    SpaceKey = 32,
    ExclamationMarkKey = 33,
    DoubleQuoteMarkKey = 34,
    SharpMarkKey = 35,
    DollarMarkKey = 36,
    PercentMarkKey = 37,
    AmpersandMarkKey = 38,
    SingleQuoteMarkKey = 39,
    LeftParenthesisMarkKey = 40,
    RightParenthesisMarkKey = 41,
    AsteriskMarkKey = 42,
    PlusMarkKey = 43,
    CommaMarkKey = 44,
    MinusMarkKey = 45,
    PeriodKey = 46,
    SlashKey = 47,
    Digit0Key = 48,
    Digit1Key,
    Digit2Key,
    Digit3Key,
    Digit4Key,
    Digit5Key,
    Digit6Key,
    Digit7Key,
    Digit8Key,
    Digit9Key,
    ColonMarkKey = 58,
    SemiColonMarkKey = 59,
    LessThanMarkKey = 60,
    EqualitySignKey = 61,
    GreaterThanSignKey = 62,
    QuestionMarkKey = 63,
    AtMarkKey = 64,
    AKey = 65,
    BKey,
    CKey,
    DKey,
    EKey,
    FKey,
    GKey,
    HKey,
    IKey,
    JKey,
    KKey,
    LKey,
    MKey,
    NKey,
    OKey,
    PKey,
    QKey,
    RKey,
    SKey,
    TKey,
    UKey,
    VKey,
    WKey,
    XKey,
    YKey,
    ZKey,
    LeftSquareBracketKey = 91,
    BackslashKey = 92,
    RightSquareBracketKey = 93,
    CaretMarkKey = 94,
    UnderScoreMarkKey = 95,
    AccentMarkKey = 96,
    LowerAKey = 97,
    LowerBKey,
    LowerCKey,
    LowerDKey,
    LowerEKey,
    LowerFKey,
    LowerGKey,
    LowerHKey,
    LowerIKey,
    LowerJKey,
    LowerKKey,
    LowerLKey,
    LowerMKey,
    LowerNKey,
    LowerOKey,
    LowerPKey,
    LowerQKey,
    LowerRKey,
    LowerSKey,
    LowerTKey,
    LowerUKey,
    LowerVKey,
    LowerWKey,
    LowerXKey,
    LowerYKey,
    LowerZKey,
    LeftCurlyBracketMarkKey = 123,
    VerticalBarMarkKey = 124,
    RightCurlyBracketMarkKey = 125,
    TildeMarkKey = 126,
    F1Key,
    F2Key,
    F3Key,
    F4Key,
    F5Key,
    F6Key,
    F7Key,
    F8Key,
    F9Key,
    F10Key,
    F11Key,
    F12Key,
    F13Key,
    F14Key,
    F15Key,
    F16Key,
    F17Key,
    F18Key,
    F19Key,
    F20Key,
    TVPreviousChannel,
    TVChannelDownKey,
    TVChannelUpKey,
    TVVolumeUpKey,
    TVVolumeDownKey,
    TVMuteKey,
    TVChannelList,
    TVChannelGuide,
    TVSimpleMenu,
    TVReturnKey,
    TVExitKey,
    TVInfoKey,
    TVRedKey,
    TVGreenKey,
    TVYellowKey,
    TVBlueKey,
    TVEManual,
    TVExtraApp,
    TVSearch,
    TVPictureSize,
    TVSleep,
    TVCaption,
    TVMore,
    TVBTVoice,
    TVColor,
    TVPlayBack,
    TVMenuKey,
    MediaFastForwardKey,
    MediaPauseKey,
    MediaPlayKey,
    MediaPlayPauseKey,
    MediaRecordKey,
    MediaRewindKey,
    MediaStopKey,
    MediaTrackNextKey,
    MediaTrackPreviousKey,
    TVKey,
    TV3DModeKey,
    TVAntennaCableKey,
    TVAudioDescriptionKey,
    TVAudioDescriptionMixDownKey,
    TVAudioDescriptionMixUpKey,
    TVContentsMenuKey,
    TVDataServiceKey,
    TVInputKey,
    TVInputComponent1Key,
    TVInputComponent2Key,
    TVInputComposite1Key,
    TVInputComposite2Key,
    TVInputHDMI1Key,
    TVInputHDMI2Key,
    TVInputHDMI3Key,
    TVInputHDMI4Key,
    TVInputVGA1Key,
    TVMediaContextKey,
    TVNetworkKey,
    TVNumberEntryKey,
    TVPowerKey,
    TVRadioServiceKey,
    TVSatelliteKey,
    TVSatelliteBSKey,
    TVSatelliteCSKey,
    TVSatelliteToggleKey,
    TVTerrestrialAnalogKey,
    TVTerrestrialDigitalKey,
    TVTimerKey,
    TVHomeKey,
    MediaAppsKey,
    MediaAudioTrackKey,
    MediaLastKey,
    MediaSkipBackwardKey,
    MediaSkipForwardKey,
    MediaStepBackwardKey,
    MediaStepForwardKey,
    MediaTopMenuKey,
    BrowserBackKey,
    BrowserFavoritesKey,
    BrowserForwardKey,
    BrowserHomeKey,
    BrowserRefreshKey,
    BrowserSearchKey,
    BrowserStopKey,
};

enum MouseButtonValue {
    NoButton = 0,
    LeftButton = 0,
    MiddleButton = 1,
    RightButton = 2
};

enum MouseButtonsValue {
    NoButtonDown = 0,
    LeftButtonDown = 1,
    RightButtonDown = 1 << 1,
    MiddleButtonDown = 1 << 2,
};

enum TTSMode {
    Default = 0,
    Forced = 1,
};

enum class WebSecurityMode { Enable = 0, Disable = 1 };

enum class IdleModeJob {
    ClearDrawnBuffers = 1,
    ForceGC = 1 << 1, // it also includes calling malloc_trim(0)
    DropDecodedImageBuffer = 1 << 2,

    IdleModeFull = ClearDrawnBuffers | ForceGC | DropDecodedImageBuffer,
    IdleModeMiddle = ForceGC,
    IdleModeNone = 0,

    IdleModeDefault = IdleModeFull
};

constexpr int IdleModeCheckDefaultIntervalInMS{ 3000 };
} // namespace LWE

#endif
